Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.jdbc.object
Class MappingSqlQueryWithParameters<T>

    java.lang.Object
      org.springframework.jdbc.object.RdbmsOperation
          org.springframework.jdbc.object.SqlOperation
              org.springframework.jdbc.object.SqlQuery<T>
                  org.springframework.jdbc.object.MappingSqlQueryWithParameters<T>

All Implemented Interfaces:
  InitializingBean

Direct Known Subclasses:
  MappingSqlQuery

    public abstract class MappingSqlQueryWithParameters<T>

extends SqlQuery<T>

Reusable RDBMS query in which concrete subclasses must implement the abstract mapRow(ResultSet, int) method to map each row of the JDBC ResultSet into an object.

Such manual mapping is usually preferable to "automatic" mapping using reflection, which can become complex in non-trivial cases. For example, the present class allows different objects to be used for different rows (for example, if a subclass is indicated). It allows computed fields to be set. And there's no need for ResultSet columns to have the same names as bean properties. The Pareto Principle in action: going the extra mile to automate the extraction process makes the framework much more complex and delivers little real benefit.

Subclasses can be constructed providing SQL, parameter types and a DataSource. SQL will often vary between subclasses.

Author:
  Rod Johnson, Thomas Risberg, Jean-Pierre Pawlak
See Also:
  `MappingSqlQuery`, `SqlQuery`

Nested Class Summary
`protected class` | `MappingSqlQueryWithParameters.RowMapperImpl` Implementation of RowMapper that calls the enclosing class's `mapRow` method for each row.

Field Summary

Fields inherited from class org.springframework.jdbc.object.RdbmsOperation
`logger`

Constructor Summary
`MappingSqlQueryWithParameters()` Constructor to allow use as a JavaBean
`MappingSqlQueryWithParameters(DataSource ds, String sql)` Convenient constructor with DataSource and SQL string.

Method Summary
`protected abstract T` | `mapRow(ResultSet rs, int rowNum, Object[] parameters, Map context)` Subclasses must implement this method to convert each row of the ResultSet into an object of the result type.
`protected RowMapper<T>` | `newRowMapper(Object[] parameters, Map context)` Implementation of protected abstract method.

Methods inherited from class org.springframework.jdbc.object.SqlQuery
`execute, execute, execute, execute, execute, execute, execute, execute, execute, execute, execute, execute, executeByNamedParam, executeByNamedParam, findObject, findObject, findObject, findObject, findObject, findObject, findObject, findObject, findObject, findObject, findObjectByNamedParam, findObjectByNamedParam, getRowsExpected, setRowsExpected`

Methods inherited from class org.springframework.jdbc.object.SqlOperation
`compileInternal, getParsedSql, newPreparedStatementCreator, newPreparedStatementCreator, newPreparedStatementSetter, onCompileInternal`

Methods inherited from class org.springframework.jdbc.object.RdbmsOperation
`afterPropertiesSet, allowsUnusedParameters, checkCompiled, compile, declareParameter, getDeclaredParameters, getGeneratedKeysColumnNames, getJdbcTemplate, getResultSetType, getSql, isCompiled, isReturnGeneratedKeys, isUpdatableResults, setDataSource, setFetchSize, setGeneratedKeysColumnNames, setJdbcTemplate, setMaxRows, setParameters, setQueryTimeout, setResultSetType, setReturnGeneratedKeys, setSql, setTypes, setUpdatableResults, supportsLobParameters, validateNamedParameters, validateParameters`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### MappingSqlQueryWithParameters

    public MappingSqlQueryWithParameters()

  Constructor to allow use as a JavaBean

### MappingSqlQueryWithParameters

    public MappingSqlQueryWithParameters(DataSource ds,
                                         String sql)

  Convenient constructor with DataSource and SQL string.

  Parameters:
    `ds` - DataSource to use to get connections
    `sql` - SQL to run

Method Detail

### newRowMapper

    protected RowMapper<T> newRowMapper(Object[] parameters,
                                        Map context)

  Implementation of protected abstract method. This invokes the subclass's implementation of the mapRow() method.

  Specified by:
    `newRowMapper` in class `SqlQuery<T>`
  Parameters:
    `parameters` - the parameters to the `execute()` method, in case subclass is interested; may be `null` if there were no parameters.
    `context` - contextual information passed to the `mapRow` callback method. The JDBC operation itself doesn't rely on this parameter, but it can be useful for creating the objects of the result list.
  See Also:
    `SqlQuery.execute(java.lang.Object[], java.util.Map)`

### mapRow

    protected abstract T mapRow(ResultSet rs,
                                int rowNum,
                                Object[] parameters,
                                Map context)
                         throws SQLException

  Subclasses must implement this method to convert each row of the ResultSet into an object of the result type.

  Parameters:
    `rs` - ResultSet we're working through
    `rowNum` - row number (from 0) we're up to
    `parameters` - to the query (passed to the execute() method). Subclasses are rarely interested in these. It can be `null` if there are no parameters.
    `context` - passed to the execute() method. It can be `null` if no contextual information is need.
  Returns:
    an object of the result type
  Throws:
    `SQLException` - if there's an error extracting data. Subclasses can simply not catch SQLExceptions, relying on the framework to clean up.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD